// Unstretch and Flip Phone Bar Image (PTRSCLL)
// Bar Image Resolution Ratio = round(res_width*0.053125) x res_height
cbuffer cb0 : register(b0) {float4 cb0[16];}
cbuffer cb1 : register(b1) {float4 cb1[6];}

// 3Dmigoto declarations
#define cmp -
#define FLIP IniParams[101].x
#define PREVIEW IniParams[101].y
#define UNSTRETCH IniParams[101].z
#define HIDE_UID IniParams[101].w
Texture1D<float4> IniParams : register(t120);
Texture2D<float4> StereoParams : register(t125);

void main(
  float4 v0 : POSITION0,
  float4 v1 : COLOR0,
  float2 v2 : TEXCOORD0,
  out float4 o0 : SV_POSITION0,
  out float4 o1 : COLOR0,
  out float2 o2 : TEXCOORD0)
{
  float4 r0,r1;
  uint4 bitmask, uiDest;
  float4 fDest;

  o0.xyzw = (
    cb0[15].xyzw
    + cb0[12].xyzw * v0.xxxx
    + cb0[13].xyzw * v0.yyyy
    + cb0[14].xyzw * v0.zzzz
  );

  o1.xyzw = cb1[0].xyzw * v1.xyzw;
  
  if (UNSTRETCH) {
    o2.xy = float2(
      v2.x * cb1[5].x + cb1[5].z,
      0.5 * (1 - (v0.y * abs(cb0[13].y)))
    );

    if (FLIP) {
      o2.y = 1 - o2.y;
    }
    if (PREVIEW) {
      o2.y *= 1.2655;
      o2.y -= 0.16;
    }
  }

  else {
    // Use Default Texcoord
    o2.xy = float2(
      v2.x * cb1[5].x + cb1[5].z,
      v2.y * cb1[5].y + cb1[5].w
    );

    // Hide Phone UID
    if (HIDE_UID) {
      if (
        (0.9 < abs(o0.y)) &&
        (0.3 < o0.x && o0.x < 0.55)
      ) {
        o0.xyzw = float4(0, 0, 0, 0);
      }
    }
  }

  return;
}
